package cn.iocoder.yudao.module.mes.service.errorrecord;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.mes.controller.admin.errorrecord.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.errorrecord.ErrorRecordDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.mes.dal.mysql.errorrecord.ErrorRecordMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;

/**
 * 错误记录 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class ErrorRecordServiceImpl implements ErrorRecordService {

    @Resource
    private ErrorRecordMapper errorRecordMapper;

    @Override
    public Long createErrorRecord(ErrorRecordSaveReqVO createReqVO) {
        // 插入
        ErrorRecordDO errorRecord = BeanUtils.toBean(createReqVO, ErrorRecordDO.class);
        errorRecordMapper.insert(errorRecord);
        // 返回
        return errorRecord.getId();
    }

    @Override
    public void updateErrorRecord(ErrorRecordSaveReqVO updateReqVO) {
        // 校验存在
        validateErrorRecordExists(updateReqVO.getId());
        // 更新
        ErrorRecordDO updateObj = BeanUtils.toBean(updateReqVO, ErrorRecordDO.class);
        errorRecordMapper.updateById(updateObj);
    }

    @Override
    public void deleteErrorRecord(Long id) {
        // 校验存在
        validateErrorRecordExists(id);
        // 删除
        errorRecordMapper.deleteById(id);
    }

    private void validateErrorRecordExists(Long id) {
        if (errorRecordMapper.selectById(id) == null) {
            throw exception(ERROR_RECORD_NOT_EXISTS);
        }
    }

    @Override
    public ErrorRecordDO getErrorRecord(Long id) {
        return errorRecordMapper.selectById(id);
    }

    @Override
    public PageResult<ErrorRecordDO> getErrorRecordPage(ErrorRecordPageReqVO pageReqVO) {
        return errorRecordMapper.selectPage(pageReqVO);
    }

}